unit BookMain;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls,
  VarFileU, RidKeyU, PairingU;

type
  TfrmMain = class(TForm)
    pgcMain: TPageControl;
    tshAut: TTabSheet;
    lblAut: TLabel;
    lblAddNewAut: TLabel;
    lblDirFetchAut: TLabel;
    lblKillAut: TLabel;
    bbnFetchAut: TBitBtn;
    lbxAutF: TListBox;
    edtAut: TEdit;
    tshCat: TTabSheet;
    lblCat: TLabel;
    lblAddNewCat: TLabel;
    lbl: TLabel;
    lblKillCat: TLabel;
    bbnFetchCat: TBitBtn;
    edtCat: TEdit;
    lbxCatF: TListBox;
    tshBook: TTabSheet;
    lblTitle: TLabel;
    lblAutBk: TLabel;
    lblCatBk: TLabel;
    lbxChosenAut: TListBox;
    lbxChosenCat: TListBox;
    lblDirections: TLabel;
    lblComment: TLabel;
    edtTitle: TEdit;
    lbxAut: TListBox;
    memComment: TMemo;
    lbxCat: TListBox;
    bbnStore: TBitBtn;
    bbnDelete: TBitBtn;
    pnlNavigate: TPanel;
    bbnNext: TBitBtn;
    bbnLast: TBitBtn;
    bbnPrev: TBitBtn;
    bbnFirst: TBitBtn;
    vrfBook: TVarFile;
    vrfAut: TVarFile;
    vrfCat: TVarFile;
    rkyAut: TRidKey;
    paiAutBk: TPairing;
    paiCatBk: TPairing;
    rkyCat: TRidKey;
    lblAutCat: TLabel;
    bbnEndScan: TBitBtn;
    bbnEdit: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure bbnStoreClick(Sender: TObject);
    procedure bbnDeleteClick(Sender: TObject);
    procedure lbxAutClick(Sender: TObject);
    procedure lbxCatClick(Sender: TObject);
    procedure lbxChosenAutClick(Sender: TObject);
    procedure lbxChosenCatClick(Sender: TObject);
    procedure bbnFetchAutClick(Sender: TObject);
    procedure bbnFetchCatClick(Sender: TObject);
    procedure bbnNextClick(Sender: TObject);
    procedure bbnLastClick(Sender: TObject);
    procedure bbnPrevClick(Sender: TObject);
    procedure bbnFirstClick(Sender: TObject);
    procedure bbnEndScanClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bbnEditClick(Sender: TObject);
  private
    { Private declarations }
    AutRid:  cardinal;
    CatRid:  cardinal;
    BookRid: cardinal;
    FindBook: RidArrayPtr;
    ScanIndex: cardinal;
    procedure BookStoreControls;
    procedure BookLoadControls;
    procedure ShowBook;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation


{$R *.DFM}

type
  BigRec = array [0..65000] of byte;
  BigRecPtr = ^BigRec;

function PickAut(Buf: pointer): ShortString;

var
  S: array [0..30] of char;

begin
  move(Buf^,S,30);
  Result := S;
  end;


function PickCat(Buf: pointer): ShortString;

var
  S: array [0..15] of char;

begin
  move(Buf^,S,15);
  Result := S;
  end;


procedure TfrmMain.FormCreate(Sender: TObject);
var
  j: cardinal;

begin
  vrfAut.Open;
  rkyAut.ExtractFromFile(vrfAut,PickAut);
  {rkyAut.LoadFromFile;}
  if rkyAut.Count > 0 then
    for j := 1 to rkyAut.Count do
      lbxAutF.Items.Add(rkyAut.KeyByIndex(j));
  AutRid := 0;

  vrfCat.Open;
  rkyCat.ExtractFromFile(vrfCat,PickCat);
  {rkyCat.LoadFromFile;}
  if rkyCat.Count > 0 then
    for j := 1 to rkyCat.Count do
      lbxCatF.Items.Add(rkyCat.KeyByIndex(j));
  CatRid := 0;

  lbxAut.Items.Assign(lbxAutF.Items);
  lbxCat.Items.Assign(lbxCatF.Items);
  vrfBook.Open;
  BookRid := 0;

  paiAutBk.LoadFromFile;
  paiCatBk.LoadFromFile;
  pnlNavigate.Enabled := FALSE;
  end;


procedure TFrmMain.BookStoreControls;
{if BookRid = 0 we insert, if not we restore}

var
  RL,j: cardinal;
  Buf: BigRecPtr;
  RN: longint;

begin
  if edtTitle.Text = '' then exit;
  RL := 51+length(memComment.Text);
  Buf := AllocMem(RL);
  move(edtTitle.Text[1],Buf^,Length(edtTitle.Text));
  move(memComment.Text[1],Buf^[51],Length(memComment.Text));
  if BookRid = 0 then begin
    RN := vrfBook.GetARid;
    vrfBook.Insert(RN,Buf,RL);
    BookRid := RN;
    end
  else vrfBook.Restore(BookRid,Buf,RL);
  for j := 1 to lbxChosenAut.Items.Count do
    paiAutBk.Add(BookRid,rkyAut.RidOf(lbxChosenAut.Items[j-1]));
  for j := 1 to lbxChosenCat.Items.Count do
    paiCatBk.Add(bookRid,rkyCat.RidOf(lbxChosenCat.Items[j-1]));
  FreeMem(Buf);
  if paiAutBk.Modified then paiAutBk.SaveToFile;
  if paiCatBk.Modified then paiCatBk.SaveToFile;
  if not pnlNavigate.Enabled then begin
    BookRid := 0;
    BookLoadControls;
    end;
  end;


procedure TfrmMain.BookLoadControls;

var
  RL,j: cardinal;
  RAP: RidArrayPtr;
  S: PChar;
  Buf: BigRecPtr;

begin
  edtTitle.Text := '';
  memComment.Text := '';
  lbxChosenAut.Items.Clear;
  lbxChosenCat.Items.Clear;
  if BookRid = 0 then exit;
  RL := vrfBook.GetBufSize(BookRid);
  if RL = 0 then exit;
  GetMem(Buf,RL);
  vrfBook.Fetch(BookRid,Buf);
  S := StrAlloc(RL); fillchar(S^,RL,0);
  move(Buf^,S^,50);
  edtTitle.Text := S;
  if RL > 51 then begin
    fillchar(S^,RL,0);
    move(Buf^[51],S^,RL-51);
    memComment.Text := S;
    end;
  StrDispose(S);
  FreeMem(Buf);
  paiAutBk.BsOf(BookRid,RAP);
  for j := 1 to RAP^[0] do
    lbxChosenAut.Items.Add(rkyAut.KeyOf(RAP^[j]));
  Reclaim(RAP);
  paiCatBk.BsOf(BookRid,RAP);
  for j := 1 to RAP^[0] do
    lbxChosenCat.Items.Add(rkyCat.KeyOf(RAP^[j]));
  Reclaim(RAP);
  ActiveControl := edtTitle;
  end;

procedure TfrmMain.bbnStoreClick(Sender: TObject);

var
  RN: longint;
  Buf: BigRecPtr;

begin
  Buf := AllocMem(31);
  case pgcMain.ActivePage.PageIndex of
    0:  {Authors} begin
      if edtAut.Text = '' then exit;
      move(edtAut.Text[1],Buf^,Length(edtAut.Text));
      if AutRid = 0 then begin
        RN := vrfAut.GetARid;
        vrfAut.Insert(RN,Buf,31);
        AutRid := RN;
        end
      else begin
        lbxAutF.Items.Delete(lbxAutF.ItemIndex);
        rkyAut.DeleteR(AutRid);
        vrfAut.Restore(AutRid,Buf,31);
        end;
      rkyAut.Add(AutRid,edtAut.Text);
      lbxAutF.Items.Add(edtAut.Text);
      lbxAut.Items.Add(edtAut.Text);
      edtAut.Text := ''; AutRid := 0;
      end;
    1:  {Categories} begin
      if edtCat.Text = '' then exit;
      move(edtCat.Text[1],Buf^,Length(edtCat.Text));
      if CatRid = 0 then begin
        RN := vrfCat.GetARid;
        vrfCat.Insert(RN,Buf,16);
        CatRid := RN;
        end
      else begin
        lbxCatF.Items.Delete(lbxCatF.ItemIndex);
        rkyCat.DeleteR(CatRid);
        vrfCat.Restore(CatRid,Buf,16);
        end;
      rkyCat.Add(CatRid,edtCat.Text);
      lbxCatF.Items.Add(edtCat.Text);
      lbxCat.Items.Add(edtCat.Text);
      edtCat.Text := ''; CatRid := 0;
      end;
    2: {Books} BookStoreControls;
    end;
  FreeMem(Buf);
  end;



procedure TfrmMain.bbnDeleteClick(Sender: TObject);

var
  RN: longint;

begin
  case pgcMain.ActivePage.PageIndex of
    0: {Authors} begin
      RN := rkyAut.RidOf(lbxAutF.Items[lbxAutF.ItemIndex]);
      if MessageDlg('Really! Delete this author?',
         mtConfirmation,[mbYes,mbNo],0) = mrNo then exit;
      rkyAut.DeleteR(RN);
      vrfAut.DeletePush(RN);
      lbxAutF.Items.Delete(lbxAutF.ItemIndex);
      lbxAut.Items.Assign(lbxAutF.Items);
      paiAutBk.DeleteAllB(RN);
      if paiAutBk.Modified then paiAutBk.SaveToFile;
      AutRid := 0; edtAut.Text := '';
      end;
    1: {Categories} begin
      RN := rkyCat.RidOf(lbxCatF.Items[lbxCatF.ItemIndex]);
      if MessageDlg('Really! Delete this category?',
         mtConfirmation,[mbYes,mbNo],0) = mrNo then exit;
      rkyCat.DeleteR(RN);
      vrfCat.DeletePush(RN);
      lbxCatF.Items.Delete(lbxCatF.ItemIndex);
      lbxCat.Items.Assign(lbxCatF.Items);
      paiCatBk.DeleteAllB(RN);
      if paiCatBk.Modified then paiCatBk.SaveToFile;
      CatRid := 0; edtCat.Text := '';
      end;
    2: {Books} begin
      if BookRid = 0 then exit;
      if MessageDlg('Really! Delete this book?',
         mtConfirmation,[mbYes,mbNo],0) = mrNo then exit;
      vrfBook.DeletePush(BookRid);
      paiAutBk.DeleteAllA(BookRid);
      if paiAutBk.Modified then paiAutBk.SaveToFile;
      paiCatBk.DeleteAllA(BookRid);
      if paiCatBk.Modified then paiCatBk.SaveToFile;
      BookRid := 0;
      BookLoadControls; {Erase the screen}
      end;
    end;
  end;

procedure TfrmMain.lbxAutClick(Sender: TObject);
begin
  lbxChosenAut.Items.Add(lbxAut.Items[lbxAut.ItemIndex]);
end;

procedure TfrmMain.lbxCatClick(Sender: TObject);
begin
  lbxChosenCat.Items.Add(lbxCat.Items[lbxCat.ItemIndex]);
end;

procedure TfrmMain.lbxChosenAutClick(Sender: TObject);
begin
  if BookRid <> 0 then
    paiAutBk.Delete(BookRid,
      rkyAut.RidOf(lbxChosenAut.Items[lbxChosenAut.ItemIndex]));
  lbxChosenAut.Items.Delete(lbxChosenAut.ItemIndex);
end;

procedure TfrmMain.lbxChosenCatClick(Sender: TObject);
begin
  if BookRid <> 0 then
    paiCatBk.Delete(BookRid,
      rkyCat.RidOf(lbxChosenCat.Items[lbxChosenCat.ItemIndex]));
  lbxChosenCat.Items.Delete(lbxChosenCat.ItemIndex);
end;


procedure TfrmMain.ShowBook;

begin
  pgcMain.ActivePage := tshBook; {set to book page}
  BookRid := FindBook^[ScanIndex];  {First book}
  BookLoadControls;
  end;

procedure TfrmMain.bbnFetchAutClick(Sender: TObject);
begin
  if pnlNavigate.Enabled then bbnEndScanClick(Sender);
  Reclaim(FindBook);
  paiAutBk.AsOf(rkyAut.RidOf(lbxAutF.Items[lbxAutF.ItemIndex]),FindBook);
  if FindBook^[0] = 0 then begin
    ShowMessage('No books for this author');
    exit;
    end;
  pnlNavigate.Enabled := TRUE;
  ScanIndex := 1;
  ShowBook;
end;


procedure TfrmMain.bbnFetchCatClick(Sender: TObject);
begin
  if pnlNavigate.Enabled then bbnEndScanClick(Sender);
  Reclaim(FindBook);
  paiCatBk.AsOf(rkyCat.RidOf(lbxCatF.Items[lbxCatF.ItemIndex]),FindBook);
  if FindBook^[0] = 0 then begin
    ShowMessage('No books for this Category');
    end;
  pnlNavigate.Enabled := TRUE;
  ScanIndex := 1;
  ShowBook;
end;

procedure TfrmMain.bbnNextClick(Sender: TObject);
begin
  if ScanIndex < FindBook^[0] then inc(ScanIndex);
  ShowBook;
end;

procedure TfrmMain.bbnLastClick(Sender: TObject);
begin
  ScanIndex := FindBook^[FindBook^[0]];
  ShowBook;
end;

procedure TfrmMain.bbnPrevClick(Sender: TObject);
begin
  if ScanIndex > 1 then dec(ScanIndex);
  ShowBook;
end;

procedure TfrmMain.bbnFirstClick(Sender: TObject);
begin
  ScanIndex := 1;
  ShowBook;
end;

procedure TfrmMain.bbnEndScanClick(Sender: TObject);
begin
  pnlNavigate.Enabled := FALSE;
  Reclaim(FindBook);
  BookRid := 0;
  BookLoadControls;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  if rkyAut.Modified then rkyAut.SaveToFile;
  if rkyCat.Modified then rkyCat.SaveToFile;
  if paiAutBk.Modified then paiAutBk.SaveToFile;
  if paiCatBk.Modified then paiCatBk.SaveToFile;
  Reclaim(FindBook);
  inherited;
end;



procedure TfrmMain.bbnEditClick(Sender: TObject);

var
  RN: cardinal;
  Buf: array [0..30] of char;

begin
  case pgcMain.ActivePage.PageIndex of
    0: {Authors} begin
      RN := rkyAut.RidOf(lbxAutF.Items[lbxAutF.ItemIndex]);
      vrfAut.Fetch(RN,@Buf);
      edtaut.Text := Buf;
      AutRid := RN;
      ActiveControl := edtAut;
      end;
    1: {Categories} begin
      RN := rkyCat.RidOf(lbxCatF.Items[lbxCatF.ItemIndex]);
      vrfCat.Fetch(RN,@Buf);
      edtCat.Text := Buf;
      CatRid := RN;
      ActiveControl := edtCat;
      end;
    2: {books}
    end;
end;

end.
