unit CreateU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  LocItem = record
    start:  longint;
    count:  longint;
    end;

  Prefix = record
    RecCapacity:  longint;
    RecCount:     longint;
    MaxRec:       longint;
    FreeCapacity: longint;
    FreeCount:    longint;
    MaxFree:      longint;
    BlockSize:    longint;
    NextRid:      longint;
    end;

  LocList = array [0..0] of LocItem;
  LocListPtr = ^LocList;



type
  TfrmCreate = class(TForm)
    lblFileName: TLabel;
    lblRecCapacity: TLabel;
    lblFreeCapacity: TLabel;
    lblBlockSize: TLabel;
    edtFileName: TEdit;
    edtRecCapacity: TEdit;
    edtFreeCapacity: TEdit;
    edtBlockSize: TEdit;
    btnDoCreate: TButton;
    btnReturn: TButton;
    odgCreate: TOpenDialog;
    procedure btnDoCreateClick(Sender: TObject);
    procedure btnReturnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmCreate: TfrmCreate;

implementation

var
  P: Prefix;
  LP: pointer;
  F: file;


{$R *.DFM}

procedure TfrmCreate.btnDoCreateClick(Sender: TObject);

var
  OK: boolean;

begin
  OK := TRUE;
  fillchar(P,sizeof(P),0);
  {Check that everything is OK}
  try
    P.RecCapacity := StrToInt(edtRecCapacity.Text);
  except
    on EConvertError do begin
      ShowMessage('Error in maximum '+
            'number of records.');
      OK := FALSE;
      end;
  end;
 try
    P.FreeCapacity := StrToInt(edtFreeCapacity.Text);
 except
   on EConvertError do begin
      ShowMessage('Error in number '+
             'of free slots.');
      OK := FALSE;
      end;
  end;
  try
    P.BlockSize := StrToInt(edtBlockSize.Text);
  except
    on EConvertError do begin
      ShowMessage('Error in Block Size.');
      OK := FALSE;
      end;
  end;
  if edtFileName.Text = '' then begin
    ShowMessage('No file named.');
    OK := FALSE
    end;
  if not OK then exit;
  P.NextRid := 1;
  AssignFile(F,edtFileName.Text);
  rewrite(F,1);
  BlockWrite(F,P,32);
  GetMem(LP,8*P.RecCapacity);
  fillchar(LP^,8*P.RecCapacity,0);
  BlockWrite(F,LP^,8*P.RecCapacity);
  FreeMem(LP,8*P.RecCapacity);
  GetMem(LP,8*P.FreeCapacity);
  fillchar(LP^,8*P.FreeCapacity,0);
  BlockWrite(F,LP^,8*P.FreeCapacity);
  FreeMem(LP,8*P.FreeCapacity);
  CloseFile(F);
  end;





procedure TfrmCreate.btnReturnClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmCreate.FormActivate(Sender: TObject);
begin
  if odgCreate.Execute then edtFileName.Text := odgCreate.FileName;
end;

end.
