unit ReportU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmReport = class(TForm)
    lblFileName: TLabel;
    cbxRec: TCheckBox;
    memReportArea: TMemo;
    btnDisplay: TButton;
    btnReturn: TButton;
    dlgOpen: TOpenDialog;
    cbxFree: TCheckBox;
    procedure btnDisplayClick(Sender: TObject);
    procedure btnReturnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmReport: TfrmReport;

implementation

{$R *.DFM}

type
  LocItem = record
    start:  longint;
    count:  longint;
    end;
  LocArray = array [0..0] of LocItem;
  LocPtr = ^LocArray;

  Prefix = record
    RecCapacity:  longint;
    RecCount:     longint;
    MaxRec:       longint;
    FreeCapacity: longint;
    FreeCount:    longint;
    MaxFree:      longint;
    BlockSize:    longint;
    NextRid:      longint;
    end;



var
  TheFileNAme: string;
  TheFile: file;
  P: Prefix;

procedure TfrmReport.FormActivate(Sender: TObject);
begin
  memReportArea.Lines.Clear;
  cbxRec.checked := FALSE;
  cbxFree.checked := FALSE;
  dlgOpen.Execute;
  if dlgOpen.FileName <> '' then begin
    TheFileName := dlgOpen.FileName;
    lblFileName.Caption := 'Working with file: '+TheFileName;
    end;

end;

procedure TfrmReport.btnDisplayClick(Sender: TObject);

var
  j: integer;
  LP: LocPtr;

begin
  AssignFile(TheFile,TheFileName);
  reset(TheFile,1);
  seek(TheFile,0);
  BlockRead(TheFile,P,32);
  memReportArea.Clear;
  with memReportArea.Lines do begin
    Add('RecCapacity = '+IntToStr(P.RecCapacity));
    Add('RecCount = ' +IntToStr(P.RecCount));
    Add('MaxRec = '+IntToStr(P.MaxRec));
    Add('FreeCapacity = '+IntToStr(P.FreeCapacity));
    Add('FreeCount = '+IntToStr(P.FreeCount));
    Add('MaxFree = '+IntToStr(P.MaxFree));
    Add('BlockSize = '+IntToStr(P.BlockSize));
    Add('NextRid = '+IntToStr(P.NextRid));
    if cbxRec.checked then begin
      GetMem(LP,8*P.RecCapacity);
      Seek(TheFile,32);
      BlockRead(TheFile,LP^,8*P.RecCapacity);
      if P.MaxRec > 0 then begin
        Add('Records occupy these blocks');
        for j := 1 to P.MaxRec do
          if LP^[j-1].count = 0 then
            Add('Record '+IntToStr(j)+' is deleted')
          else if LP^[j-1].count = 1 then
            Add('Record '+IntToStr(j)+' occupies block '
              +IntToStr(LP^[j-1].start))
            else Add('Record '+IntToStr(j)+' occupies blocks '
             +IntToStr(LP^[j-1].start)+'-'+
              IntToStr(LP^[j-1].start+LP^[j-1].count-1));
        end;
      FreeMem(LP,8*P.RecCapacity);
      end;
    if cbxFree.checked then begin
      GetMem(LP,8*P.FreeCapacity);
      Seek(TheFile,32+8*P.RecCapacity);
      BlockRead(TheFile,LP^,8*P.FreeCapacity);
      if P.FreeCount <> 0 then begin
        Add('Free areas follow');
        for j := 1 to P.FreeCount do
          if LP^[j-1].count <> 0 then
            Add('Free area '+IntToStr(j)+' occupies blocks '
             +IntToStr(LP^[j-1].start)+'-'+
              IntToStr(LP^[j-1].start+LP^[j-1].count-1));
        end;
      FreeMem(LP,8*P.FreeCapacity);
      end;
    end;
  CloseFile(TheFile);
  end;



procedure TfrmReport.btnReturnClick(Sender: TObject);
begin
  Close;
end;

end.
